
#include <stdio.h>

// C standard:
// ISO/IEC 9899:201x    Committee Draft — December 2, 2010 N1548
// 6.7.2.2 Enumeration specifiers

// Each enumerated type shall be compatible with char, a signed integer type,
// or an unsigned integer type. The choice of type is implementation-defined,
// but shall be capable of representing the values of all the members of the
// enumeration.


enum small { S1, S2, S3, };
enum normal { N1, N2=10000, N3, N4, N5=50000 };
enum big { B1, B2, B3=1LL<<60, B4 };

#define PRINT(a)    printf("sizeof(" #a ") = %zd\n", sizeof(a))

int main(void) {
    PRINT(enum small);
    PRINT(S1);
    PRINT(enum normal);
    PRINT(N1);
    PRINT(enum big);
    PRINT(B1);
    PRINT(B3);
}
