
// source:
// https://stackoverflow.com/questions/4118016/set-stack-size-with-setrlimit-and-provoke-a-stack-overflow-segfault

#include <stdio.h>
#include <sys/resource.h>

void foo(size_t n);
void print_stack_limit(void);

#define MAX (65536*16)*8        // *MiB == default

int main(int argc, char *argv[])
{
    if (argc > 1) {
        struct rlimit lim = { MAX, MAX };
        printf("limiting stack size\n");
        if (setrlimit(RLIMIT_STACK, &lim) == -1) {
            printf("rlimit failed\n");
            return 1;
        }
    }
    print_stack_limit();

    for(int i=MAX-4096*10; i<MAX+4096*10; i+=4096)
        foo(i);

    return 0;
}

void foo(size_t n)
{
    unsigned char a[n];

    printf("foo: %zd %u\n", n, a[n-1] = 42);
}

void print_stack_limit(void)
{
    struct rlimit lim = { 0, 0 };
    if (getrlimit(RLIMIT_STACK, &lim) == -1) {
        printf("getrlimit failed\n");
        return;
    }
    printf("Stack limit: %ld B max=%ld\n", (long)lim.rlim_cur, (long)lim.rlim_max);
}


