
/*
Funkce skip_items slouží k přeskočení několika prvních položek v záznamu. Záznam je znakový řetězec
+str, ve kterém jsou jednotlivé položky odděleny znakem oddělovače delim. Funkce vrací řetězec
+zkrácený o prvních n položek. Pokud je řetězec NULL, funkce vrací hodnotu NULL. Jestli se znak
+oddělovače v řetězci nevyskytuje, funkce se chová jako by záznam obsahoval pouze jednu položku.
Příklad spuštění: skip_item("aa:bb:cc:dd", ':', 2) ==> "cc:dd"
*/

#include <stdio.h>

char *skip_items(char *str, char delim, unsigned n)
{
    // assert(delim != '\0');
    if (str == NULL)
        return NULL;
    if (n == 0)
        return str;
    char *p;
    for (p = str; *p != '\0'; ++p) {
        if (*p == delim && --n == 0)
            return p + 1;
    }
    return p;
}

// test

void test(char *s, unsigned n)
{
    printf("skip_items(\"%s\",\':\',%u) = \"%s\"\n",
           s, n, skip_items(s, ':', n));
}

int main(void)
{
    for (unsigned i = 0; i < 6u; ++i)
        test("aa:bb:cc:dd", i);
    test("::", 0);
    test("::", 1);
    test("::", 2);
    test("aa", 0);
    test("aa", 1);
    test("", 0);
    test("", 1);
    test(NULL, 1);              // depends on printf() implementation
}
