
// cancellation example

#include <stdio.h>
#include <math.h>       // exp(), expf()
#include <fenv.h>
//#pragma STDC FENV_ACCESS ON

float ff(float x) {
    return (expf(x)-1.0F)/x;
}

double fd(double x) {
    return (exp(x)-1.0)/x;
}

int main(void) {
#if 0
    fesetround(FE_TOWARDZERO);
#endif
    //float f1=0.1F;
    printf("\nEvaluate function: f(x) = (e^x - 1)/x \n\n");
    printf("  n |          x           |    float   |        double        |\n");
    double x=1.0;
    for(int i=1; i<55; ++i) {
        x/=2;
        printf(" %2d | %20.18f | %10.8f | %20.18f |\n",
                 i,     x,       ff(x),    fd(x) );
    }
    printf(" == | 0                    | 1.0        | 1.0                  |\n");
    return 0;
}
