
// Test: macro expansion, operator #, some predefined macros
// https://gcc.gnu.org/onlinedocs/cppinternals/Macro-Expansion.html

#include <stdio.h>

#define TOSTRING(x) #x
#define TOSTRING2(x) TOSTRING(x)

#define printf printf   // no infinite recursion

int main(void) {
    int line = __LINE__;
    printf("The var defined on line %d\n", line);
    printf("The printf on line %d\n", __LINE__);
    printf("The printf on line " TOSTRING(__LINE__) "\n"); // BUG
    printf("The printf on line " TOSTRING2(__LINE__) "\n");
    printf("Compiled at " __DATE__ " " __TIME__ "\n");
}
